Subject: bug#76116: 14.0.8; hyperref command bug

From: Lei Zhao <[email-masked]>
Date: Fri, 7 Feb 2025 15:09:33 +0800

Dear AUCTeX:

I have found the cause of the bug. It was caused by the function 
`TeX-arg-label`.  After I add the following advice, the bug goes away.

(defun lfj-TeX-arg-label (optional &optional prompt definition)
   (TeX-argument-insert
    (TeX-read-label optional prompt definition) optional))
(advice-add 'TeX-arg-label :override 'lfj-TeX-arg-label)

The original function was trying to add `t` as a prefix for 
`TeX-argument-insert`, which results in the aforementioned bug.

Best Regards,

Leei F. Jaw

On 2/7/25 14:05, Lei Zhao wrote:
> Dear AUCTeX:
>
>
> When I tried to use \hyperref[name]{text} form from hyperref.el, the
> command doesn't work. It reports "Wrong type argument: char-or-string-p,
> t" error.
>
> Steps to reproduce:
>
> C-c RET "hyperref" RET y "thm:mythm" "Text-for-my-theorem"
>
> Then it reports:
>
> Wrong type argument: char-or-string-p, t
>
> Emacs  : GNU Emacs 27.1 (build 1, x86_64-pc-linux-gnu, GTK+ Version 
> 3.24.33, cairo version 1.16.0)
>  of 2024-09-17, modified by Debian
> Package: 14.0.8
>
> current state:
> ==============
> (setq
>  window-system 'x
>  LaTeX-version "2e"
>  TeX-style-path '("~/.emacs.d/auctex/" 
> "/home/lei/.emacs.d/elpa/auctex-14.0.8/style"
>                   "/home/lei/.emacs.d/auctex/auto" 
> "/home/lei/.emacs.d/auctex/style"
>                   "auto" "style")
>  TeX-auto-save nil
>  TeX-parse-self nil
>  TeX-master t
>  TeX-command-list '(("TeX"
>                      "%(PDF)%(tex) %(file-line-error) %`%(extraopts) 
> %S%(PDFout)%(mode)%' %(output-dir) %t"
>                      TeX-run-TeX nil (plain-TeX-mode AmSTeX-mode 
> Texinfo-mode) :help
>                      "Run plain TeX")
>                     ("LaTeX" "%`%l%(mode)%' %T" TeX-run-TeX nil 
> (LaTeX-mode docTeX-mode)
>                      :help "Run LaTeX")
>                     ("Makeinfo" "makeinfo %(extraopts) %(o-dir) %t" 
> TeX-run-compile nil
>                      (Texinfo-mode) :help "Run Makeinfo with Info 
> output")
>                     ("Makeinfo HTML" "makeinfo %(extraopts) %(o-dir) 
> --html %t"
>                      TeX-run-compile nil (Texinfo-mode) :help
>                      "Run Makeinfo with HTML output")
>                     ("AmSTeX"
>                      "amstex %(PDFout) %`%(extraopts) %S%(mode)%' 
> %(output-dir) %t"
>                      TeX-run-TeX nil (AmSTeX-mode) :help "Run AMSTeX")
>                     ("ConTeXt" "%(cntxcom) --once %(extraopts) 
> %(execopts)%t" TeX-run-TeX
>                      nil (ConTeXt-mode) :help "Run ConTeXt once")
>                     ("ConTeXt Full" "%(cntxcom) %(extraopts) 
> %(execopts)%t" TeX-run-TeX
>                      nil (ConTeXt-mode) :help "Run ConTeXt until 
> completion")
>                     ("BibTeX" "bibtex %(O?aux)" TeX-run-BibTeX nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode
>                       ConTeXt-mode)
>                      :help "Run BibTeX")
>                     ("Biber" "biber %(output-dir) %s" TeX-run-Biber nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Run Biber")
>                     ("Texindex" "texindex %s.??" TeX-run-command nil 
> (Texinfo-mode) :help
>                      "Run Texindex")
>                     ("Texi2dvi" "%(PDF)texi2dvi %t" TeX-run-command 
> nil (Texinfo-mode)
>                      :help "Run Texi2dvi or Texi2pdf")
>                     ("View" "%V" TeX-run-discard-or-function t t :help 
> "Run Viewer")
>                     ("Print" "%p" TeX-run-command t t :help "Print the 
> file")
>                     ("Queue" "%q" TeX-run-background nil t :help "View 
> the printer queue"
>                      :visible TeX-queue-command)
>                     ("File" "%(o?)dvips %d -o %f " TeX-run-dvips t
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Generate PostScript file")
>                     ("Dvips" "%(o?)dvips %d -o %f " TeX-run-dvips nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Convert DVI file to PostScript")
>                     ("Dvipdfmx" "dvipdfmx -o %(O?pdf) %d" 
> TeX-run-dvipdfmx nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Convert DVI file to PDF with dvipdfmx")
>                     ("Ps2pdf" "ps2pdf %f %(O?pdf)" TeX-run-ps2pdf nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Convert PostScript file to PDF")
>                     ("LaTeXMk"
>                      "latexmk %(latexmk-out) %(file-line-error) 
> %(output-dir) %`%(extraopts) %S%(mode)%' %t"
>                      TeX-run-format nil (LaTeX-mode docTeX-mode) :help 
> "Run LaTeXMk")
>                     ("Glossaries" "makeglossaries %(d-dir) %s" 
> TeX-run-command nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Run makeglossaries to create glossary file")
>                     ("Index" "makeindex %(O?idx)" TeX-run-index nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Run makeindex to create index file")
>                     ("upMendex" "upmendex %(O?idx)" TeX-run-index t
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Run upmendex to create index file")
>                     ("Xindy" "texindy %s" TeX-run-command nil
>                      (plain-TeX-mode LaTeX-mode docTeX-mode 
> AmSTeX-mode Texinfo-mode)
>                      :help "Run xindy to create index file")
>                     ("Check" "lacheck %s" TeX-run-compile nil 
> (LaTeX-mode) :help
>                      "Check LaTeX file for correctness")
>                     ("ChkTeX" "chktex -v6 %s" TeX-run-compile nil 
> (LaTeX-mode) :help
>                      "Check LaTeX file for common mistakes")
>                     ("Spell" "(TeX-ispell-document \"\")" 
> TeX-run-function nil t :help
>                      "Spell-check the document")
>                     ("Clean" "TeX-clean" TeX-run-function nil t :help
>                      "Delete generated intermediate files")
>                     ("Clean All" "(TeX-clean t)" TeX-run-function nil 
> t :help
>                      "Delete generated intermediate and output files")
>                     ("Other" "" TeX-run-command t t :help "Run an 
> arbitrary command"))
>  )
>